const userService = require("../services/users.service");
exports.saveUser = async (req,res) => {
    const nom = req.body.nom;
    const prenom = req.body.prenom;
    userService.createUser(prenom,nom,(error,data)=> {
        if(error){
            return res.status(500).send("ERREUR INTERNE");
        }
        return res.status(200).send(data);
    });
}
exports.getUsers = async(req,res) => {
    userService.getUsers((error,data)=>{
        if(error){
            return res.status(500).send("Erreur interne");
        }
        return res.status(200).json({data:data});
    })
}
exports.deleteUser = async (req,res) => {
    let uuid = req.query.uuid;
    if(!uuid){
        return res.status(400).send("UUID Nulle!!!!");
    }
    userService.deleteUser(uuid,(error,data)=>{
        if(error){
            if(error == "Utilisateur introuvable"){
                return res.status(400).send(error);
            }else{
                return res.status(500).send("Erreur interne");
            }
        }
        return res.status(200).send(data);
    })
}
exports.updateUser = async (req,res) => {
    let uuid = req.params.uuid; // api/users/:abc
    let {nom,prenom} = req.body;
    userService.updateUser(uuid,nom,prenom,(error,data)=>{
        if(error){
            if(error == "Utilisateur introuvable"){
                return res.status(400).send(error);
            }else{
                return res.status(500).send("Erreur interne");
            }
        }
        return res.status(200).send(data);      
    })
}
exports.getUserById = async (req,res)=> {
    const uuid = req.params.uuid;
    userService.getUsers((error,data)=>{
        if(error){
            return res.status(500).send("Erreur Interne");
        }
        const user = data.find(user => user.id == uuid);
        return res.status(200).json({data:user});
    })
}