const notes = require("./notes");
const express = require("express");
const path = require("path");

const PORT = 3000;

const app = express();

//let mesNotes = notes.loadNotes(); // ==> ASYNCHRONE
//console.log(mesNotes);
// CALLBACK
notes.loadNotes((error,data)=>{
    console.log("Data: ", data);
})

// PROMISE
notes.loadNotesPromise()
    .then(data => console.log("Data: ", data))
    .catch(error => console.log("Error: ", error));

// ASYNC AWAIT
notes.loadNotesAsync() // RETOURNE UNE PROMESSE
    .then(data => console.log("Data: ", data))
    .catch(error => console.log("Error: ", error));

const dataAsync = async () => {
    try{
        const mesNotes = await notes.loadNotesAsync();
        console.log("Data await: ", mesNotes);
    }catch(error) { console.log(error)}
}
dataAsync();

app.use(express.static(path.join(__dirname,"public")));

app.get("/", (req,res)=>{
    res.sendFile(path.join(__dirname,"public","index.html"));
});
app.get("/home", (req,res)=>{
    res.sendFile(path.join(__dirname,"public","index.html"));
});

app.get("/api/notes", async (req,res)=>{
    try{
        const mesNotes = await notes.loadNotesAsync();
        res.json({"data":mesNotes});
    }catch(error){
        res.send("ERREUR INTERNE!!!!!!")
    }
})
app.listen(PORT, ()=>{
    console.log(`Serveur ecoute sur le port ${PORT}`);
})
