const fs = require("fs");
const util = require("util");
const readFileAsync = util.promisify(fs.readFile);

const loadNotes = (callback) => {
    // notes.json ==> BDD 
    fs.readFile("notes.json","utf8",(error, data)=>{ // ERROR FIRST
        if(error){
            console.log("Premiere tentative");
            return callback(error,[]);
        }
        // data ==> BUFFER / BINAIRE
        const dataStr = data.toString()
        console.log("OK");
        callback(null,JSON.parse(dataStr));
    })
}

const loadNotesPromise = () => {
    return new Promise((resolve,reject)=>{
        fs.readFile("notes.json", (error,data)=>{
            if (error){
                reject(error); return;
            }
            const dataStr = data.toString();
            resolve(JSON.parse(dataStr));
        });
    });
}
const loadNotesAsync = async () => {
    try {
        const data = await readFileAsync("notes.json");
        const dataStr = data.toString();
        return JSON.parse(dataStr);
    } catch(err) {
        throw err;
    }
}
module.exports = { loadNotes, 
    loadNotesPromise, loadNotesAsync }