const fs = require("fs");
const path = require("path");
const { v4: uuidv4 } = require('uuid');
const chemin = path.join(__dirname,"..","users.json");

const createUser = (prenom,nom,callback) => {
    // ETAPE 1: LIRE users.json
    let users = [];
    try{
        const data = fs.readFileSync(chemin,'utf8');
        const dataStr = data.toString();
        users = JSON.parse(dataStr);
    }catch(error) {
        console.log(error);
        return callback(error,null)
    }
    // ETAPE 2: AJOUTER un nouvel user a un tab users
    const newUser = {id: uuidv4(),nom:nom,prenom:prenom};
    users.push(newUser);
    // ETAPE 3: ECRIRE users.json
    try{
        fs.writeFileSync(chemin,JSON.stringify(users));
        return callback(null,"ECRITURE AVEC SUCCESS");
    }catch(error){
        console.log(error);
        return callback(error,null)     
    }
}
const getUsers = (callback) => {
    let users = [];
    try{
        const data = fs.readFileSync(chemin,'utf8');
        const dataStr = data.toString();
        users = JSON.parse(dataStr);
        callback(null, users);
    }catch(error){
        callback(error, null);
    }
}
const deleteUser = (uuid, callback) => {
    let users = [];
    try{
        const data = fs.readFileSync(chemin,'utf8');
        const dataStr = data.toString();
        users = JSON.parse(dataStr);
        const initSize = users.length;
        users = users.filter(user => user.id != uuid);
        if(users.length === initSize){
            return callback("Utilisateur introuvable",null);
        }
        try{
            fs.writeFileSync(chemin,JSON.stringify(users));
            callback(null,"Suppression avec succes");
        }catch(errorEcriture){callback(errorEcriture,null)}
    }catch(error) {callback(error,null);}
}
const updateUser = (uuid,nom,prenom,callback) => {
    let users = [];
    try{
        const data = fs.readFileSync(chemin,'utf8');
        const dataStr = data.toString();
        users = JSON.parse(dataStr);
        const userIndex = users.findIndex(u => u.id == uuid);
        if(userIndex < 0 ){
            return callback("Utilisateur introuvable",null);
        }   
        users[userIndex] = {id:uuid,nom:nom,prenom:prenom};
        try{
            fs.writeFileSync(chemin,JSON.stringify(users));
            callback(null,"Mise a jour avec succes");
        }catch(errorEcriture){callback(errorEcriture,null)}
    }catch(error) {callback(error,null);}
}
module.exports = {createUser,getUsers,deleteUser,
    updateUser
}